import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React, { Component } from "react";
import { icons, utils } from "zebulon-controls";
import { computeRowSearch, rowSearch, cellSearch, getRegExp } from "./utils/compute.data";
export var Search =
/*#__PURE__*/
function (_Component) {
  _inherits(Search, _Component);

  function Search(props) {
    var _this;

    _classCallCheck(this, Search);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Search).call(this, props));

    _this.handleClickNext = function (direction) {
      var _this$state = _this.state,
          cell = _this$state.cell,
          value = _this$state.value,
          rowIndexes = _this$state.rowIndexes,
          indexRowIndex = _this$state.indexRowIndex,
          properties = _this$state.properties;
      var exp = getRegExp(value);

      var cell_ = _objectSpread({}, cell);

      var index = indexRowIndex;
      cell_.columns = cellSearch(_this.props.filteredData[cell_.rows], properties, exp, cell_.columns + direction, direction);

      if (cell_.columns === null && (direction === 1 && index < rowIndexes.length - 1 || direction === -1 && index !== 0)) {
        index += direction;
        cell_.rows = rowIndexes[index];
        cell_.columns = cellSearch(_this.props.filteredData[cell_.rows], properties, exp, direction === -1 ? properties.length - 1 : 0, direction);
      }

      if (cell_.columns !== null) {
        var cellRange = _objectSpread({}, cell_, {
          columns: properties[cell_.columns].index_
        });

        _this.props.scrollTo(cellRange.rows, Math.sign(cellRange.rows - (_this.state.cell.rows || 0)), cellRange.columns, Math.sign(cellRange.columns - (_this.props.selectedCell.columns || 0)));

        _this.setState({
          cell: cell_,
          indexRowIndex: index
        });
      }
    };

    _this.handleChange = function (e) {
      var value = e.target.value;
      var exp = getRegExp(value);
      var cell = {
        rows: undefined,
        columns: undefined
      };
      var ix = -1;

      if (!utils.isNullValue(value && value !== _this.state.value)) {
        var _this$props = _this.props,
            rowStartIndex = _this$props.rowStartIndex,
            rowStopIndex = _this$props.rowStopIndex,
            filteredData = _this$props.filteredData;
        var rows = _this.state.dataStrings;
        var rowIndexes = rowSearch(rows, exp);

        _this.setState({
          value: value,
          rowIndexes: rowIndexes
        });

        if (rowIndexes.length) {
          ix = rowIndexes.findIndex(function (index) {
            return index >= rowStartIndex && index <= rowStopIndex;
          });

          if (ix === -1) {
            if (rowIndexes[rowIndexes.length - 1] > rowStopIndex) {
              ix = rowIndexes.findIndex(function (index) {
                return index > rowStopIndex;
              });
            } else {
              ix = rowIndexes.length - 1;
            }
          }

          cell.rows = rowIndexes[ix];
          var row = filteredData[cell.rows];
          cell.columns = cellSearch(row, _this.state.properties, exp);

          var cellRange = _objectSpread({}, cell, {
            columns: _this.state.properties[cell.columns].index_
          });

          _this.props.scrollTo(cellRange.rows, Math.sign(cellRange.rows - (_this.props.selectedCell.rows || 0)), cellRange.columns, Math.sign(cellRange.columns - (_this.props.selectedCell.columns || 0)), true);
        }

        _this.setState({
          value: value,
          rowIndexes: rowIndexes,
          cell: cell,
          indexRowIndex: ix
        });
      } else {
        _this.setState({
          value: value,
          rowIndexes: [],
          cell: cell,
          indexRowIndex: -1
        });
      }

      _this.input.focus();
    };

    var _filteredData = props.filteredData,
        meta = props.meta,
        dataStrings = props.dataStrings,
        _rowStartIndex = props.rowStartIndex,
        _rowStopIndex = props.rowStopIndex;

    var _properties = meta.properties.filter(function (property) {
      return !property.hidden;
    });

    _this.state = {
      dataStrings: computeRowSearch(_filteredData, _properties, dataStrings),
      value: "",
      properties: _properties,
      cell: {},
      rowStartIndex: _rowStartIndex,
      rowStopIndex: _rowStopIndex
    };
    return _this;
  }

  _createClass(Search, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("div", {
        style: {
          display: "flex"
        }
      }, React.createElement("input", {
        style: {
          width: 200
        },
        onChange: function onChange(e) {
          return _this2.handleChange(e);
        },
        value: this.state.value,
        autoFocus: true,
        ref: function ref(_ref) {
          return _this2.input = _ref;
        }
      }), React.createElement("div", {
        style: {
          background: icons.downArrow,
          backgroundSize: "cover",
          height: "1em",
          width: "1em",
          marginTop: "0.1em",
          marginRight: "0.1em"
        },
        onClick: function onClick() {
          return _this2.handleClickNext(1);
        }
      }), React.createElement("div", {
        style: {
          background: icons.upArrow,
          backgroundSize: "cover",
          height: "1em",
          width: "1em",
          marginTop: "0.4em",
          marginRight: "0.1em",
          zoom: 0.7
        },
        onClick: function onClick() {
          return _this2.handleClickNext(-1);
        }
      }), React.createElement("div", {
        style: {
          background: icons.close,
          backgroundSize: "cover",
          height: "1em",
          width: "1em",
          marginTop: "0.7em",
          zoom: 0.5,
          marginRight: "0.1em",
          marginLeft: ".6em"
        },
        onClick: this.props.onClose
      }));
    }
  }]);

  return Search;
}(Component);