import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React from "react";
import { Headers, Status } from "./TableHeaders";
import { TableFilterSort } from "./Table.filters.sorts";
import { Rows } from "./Rows";
import { Search } from "./Search";
import { utils, Filter, ContextualMenuClient } from "zebulon-controls";
import { computeData } from "./utils/compute.data";
import { computeMetaPositions } from "./utils/compute.meta"; // import { utils } from "zebulon-controls";

export var Table =
/*#__PURE__*/
function (_TableFilterSort) {
  _inherits(Table, _TableFilterSort);

  function Table(props) {
    var _this;

    _classCallCheck(this, Table);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Table).call(this, props));

    _this.onLoad = function () {
      if (_this.bLoaded) {
        _this.updated = false;
        _this.rowUpdated = false;
        _this.tableUpdated = false;

        _this.adjustScrollRows(_this.state.filteredData);

        _this.bLoaded = null;
      }
    };

    _this.onCheckAll = function () {
      var checked_ = !_this.state.checkAll;

      _this.state.filteredData.forEach(function (row) {
        return row.checked_ = checked_;
      });

      _this.setState({
        checkAll: checked_,
        updatedRows: _this.state.updatedRows
      });
    };

    var filteredData = _this.filters(props.data, props.filters); // if (props.meta.serverPagination && props.status.loaded) {
    //   status = {
    //     loaded: false,
    //     loading: true
    //   };
    //   props.data({ startIndex: 0 }).then(filteredData => {
    //     computeData(filteredData.page, props.meta, 0);
    //     if (props.onGetPage) {
    //       props.onGetPage(filteredData);
    //     }
    //     this.setState({
    //       filteredData,
    //       filteredDataLength: filteredData.filteredDataLength,
    //       status: { loaded: true, loading: false }
    //     });
    //   });
    // }
    //  else if (this.props.callbackForeignKey && filteredData.length < 2) {
    //   this.props.callbackForeignKey(
    //     filteredData.length ? filteredData.length[0] : false
    //   );
    // } // a voir serverPagination


    _this.sorts(filteredData, props.meta.properties);

    var columns = props.meta && props.meta.visibleIndexes ? props.meta.visibleIndexes[0] : 0;
    _this.state = {
      data: props.data,
      filteredData: filteredData,
      params: props.params,
      meta: props.meta,
      filters: props.filters || {},
      status: props.status,
      updatedRows: props.updatedRows,
      scroll: {
        rows: {
          index: 0,
          direction: 1,
          startIndex: 0,
          shift: 0,
          position: 0
        },
        columns: {
          index: 0,
          direction: 1,
          startIndex: 0,
          shift: 0,
          position: 0
        }
      },
      selectedRange: {
        start: {
          rows: undefined,
          columns: columns
        },
        end: {
          rows: undefined,
          columns: columns
        }
      },
      detail: {},
      text: {},
      checkAll: false,
      search: false,
      dataStrings: {}
    }; // this.state.selectedRangeAudit = this.state.selectedRange;
    // this.state.scrollAudit = this.state.scroll;

    _this.rowHeight = _this.props.rowHeight;
    _this.range = {
      start: {},
      end: {}
    };

    _this.onTableEnter();

    if (props.status && props.status.loaded) {
      _this.bLoaded = true;
    }

    _this.hasFocus = true; // if (this.props.contextualMenu) {
    //   if (typeof this.props.contextualMenu === "function") {
    //     this.customContextualMenu = this.props.contextualMenu(
    //       this.state,
    //       props
    //     );
    //   } else {
    //     this.customContextualMenu = this.props.contextualMenu;
    //   }
    // }

    return _this;
  }

  _createClass(Table, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.data !== this.props.data || nextProps.meta !== this.props.meta || nextProps.status !== this.props.status || nextProps.updatedRows !== this.props.updatedRows || nextProps.filters !== this.props.filters) {
        // const filteredData = this.filters(nextProps.data, nextProps.filters);
        var filteredData = [];
        var status = nextProps.status;
        filteredData = this.filters(nextProps.data, nextProps.filters, undefined, nextProps.updatedRows);

        if (nextProps.status.loaded && nextProps.isModal && this.props.onDoubleClick && this.props.onRowEnter) {
          var filteredData_ = filteredData,
              filter_ = Object.values(nextProps.filters)[0];

          if (filteredData_.length === 1 && ["quit", "match"].includes(nextProps.selection)) {
            this.props.onRowEnter({
              row: filteredData_[0]
            });
            this.props.onDoubleClick();
          } else if (filteredData_.length >= 1 && nextProps.selection === "match") {
            filteredData_ = filteredData_.filter(function (row) {
              return row[filter_.id] === filter_.v;
            });

            if (filteredData_.length === 1) {
              this.props.onRowEnter({
                row: filteredData_[0]
              });
              this.props.onDoubleClick();
            }
          }
        }

        this.sorts(filteredData, nextProps.meta.properties); // }

        this.setState({
          data: nextProps.data || [],
          filteredData: filteredData,
          filteredDataLength: filteredData.length,
          filters: nextProps.filters || {},
          meta: nextProps.meta,
          status: status,
          updatedRows: nextProps.updatedRows // scroll: this.state.scroll
          // selectedRange: { start: {}, end: {} },
          // scroll: {
          //   rows: {
          //     index: 0,
          //     direction: 1,
          //     startIndex: 0,
          //     shift: 0,
          //     position: 0
          //   },
          //   columns: {
          //     index: 0,
          //     direction: 1,
          //     startIndex: 0,
          //     shift: 0,
          //     position: 0
          //   }
          // }

        });

        if (status && status.loaded && this.bLoaded === undefined || nextProps.filters !== this.state.filters) {
          this.bLoaded = true;
        }

        if (status && status.loading) {
          this.bLoaded = undefined;
        }

        if (status.loaded && this.props.callbackForeignKey && filteredData.length < 2) {
          this.props.callbackForeignKey(filteredData.length === 1, filteredData[0]);
          return null;
        }
      }

      this.rowHeight = nextProps.rowHeight;
      if (nextProps.visible && !this.props.visible) this.onTableEnter(); // else if (!nextProps.visible && this.props.visible) {
      //   this.onTableQuit();
      // }

      if (!nextProps.isActive && this.props.isActive) {
        this.closeOpenedWindows(); // this.hasFocus = false;
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !this.isPasting;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      return this.onTableClose();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.onLoad();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.onLoad();
      console.log("tableUpdated");
      this.changingFilter = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          height = _this$props.height,
          width = _this$props.width,
          isModal = _this$props.isModal,
          visible = _this$props.visible,
          params = _this$props.params,
          id = _this$props.id;
      var _this$state = this.state,
          status = _this$state.status,
          meta = _this$state.meta,
          selectedRange = _this$state.selectedRange,
          updatedRows = _this$state.updatedRows,
          data = _this$state.data,
          auditedRow = _this$state.auditedRow,
          audits = _this$state.audits,
          scroll = _this$state.scroll,
          statusChanged = _this$state.statusChanged,
          filteredData,
          filteredDataLength;
      var caption = this.props.caption === "" ? null : this.props.caption || meta.table.caption;
      var selectRange = this.selectRange,
          onScroll = this.onScroll;
      var headersLength = 1 + !meta.table.noFilter * (1 + (meta.properties.findIndex(function (column) {
        return column.filterType === "between" && !column.hidden;
      }) !== -1));
      var key;
      filteredData = this.state.filteredData;
      filteredDataLength = this.state.filteredData.length; // }
      //  actions

      var actions = auditedRow || isModal || meta.properties.length === 0 ? [] : meta.table.actions.filter(function (action) {
        return !action.hidden;
      }) || [];

      if (!visible) {
        return null;
      } else if (status.loading || status.loadingConfig) {
        return React.createElement("div", null, "Loading data...");
      } else if (status.error) {
        if (status.error.message === "No rows retrieved") {
          return React.createElement("div", {
            style: {
              width: "max-content"
            }
          }, "No rows retrieved");
        } else {
          return React.createElement("div", {
            style: {
              color: "red",
              width: "max-content"
            }
          }, React.createElement("p", null, status.error.type), React.createElement("p", null, status.error.message));
        }
      } else if (data.length === 0 && meta.properties.length === 0) {
        return null;
      }

      var noUpdate = !this.isInPage(scroll.rows) || this.noUpdate;
      this.noUpdate = false; // -----------------------------------
      // Filter check list
      // -----------------------------------

      var _this$state2 = this.state,
          openedFilter = _this$state2.openedFilter,
          filters = _this$state2.filters;
      this.openedFilter = null;

      if (openedFilter !== undefined && filters[openedFilter]) {
        var _filters$openedFilter = filters[openedFilter],
            _top = _filters$openedFilter.top,
            _left = _filters$openedFilter.left,
            items = _filters$openedFilter.items,
            _v = _filters$openedFilter.v,
            _caption = _filters$openedFilter.caption,
            computedWidth = _filters$openedFilter.computedWidth;
        key = "filter-".concat(id);
        this.filter = React.createElement(Filter, {
          id: key,
          key: key,
          items: items,
          title: _caption,
          filter: _v,
          style: {
            position: "absolute",
            border: "solid 0.1em rgba(0, 0, 0, 0.5)",
            backgroundColor: "white",
            fontFamily: "inherit",
            top: _top,
            left: _left,
            width: Math.max(computedWidth * 1.5, 150),
            zIndex: 3,
            opacity: 1
          },
          onOk: this.onChangeFilterValues,
          ref: function ref(_ref) {
            return _this2.openedFilter = _ref;
          }
        });
      } else {
        this.filter = undefined;
      } // ------------------------
      // text area
      // ------------------------


      var _this$state$text = this.state.text,
          top = _this$state$text.top,
          left = _this$state$text.left,
          v = _this$state$text.v,
          editable = _this$state$text.editable,
          label = _this$state$text.label;

      if (top !== undefined) {
        key = "textarea-".concat(id);
        this.text = React.createElement("div", {
          id: key,
          key: key,
          style: {
            // position: "absolute", toto
            border: "solid 0.1em rgba(0, 0, 0, 0.5)",
            backgroundColor: "white",
            top: top + (headersLength - 2) * this.rowHeight,
            left: left,
            zIndex: 3,
            opacity: 1
          }
        }, React.createElement("div", null, label, " "), React.createElement("textarea", {
          rows: "10",
          cols: "80",
          id: "textarea",
          tabIndex: 0,
          style: {
            top: top,
            left: left,
            font: "inherit"
          },
          disabled: !editable,
          autoFocus: true,
          value: v || "",
          onChange: this.handleTextChange // ref={ref => (this.focused = ref)}

        }));
      } else {
        this.text = undefined;
      } // ------------------------
      // Detail
      // ------------------------


      var detail = this.state.detail.content;

      if (detail) {
        var row = selectedRange.end.rows !== undefined ? this.getRow(selectedRange.end.rows) : {};
        var _status = updatedRows[row.index_]; //       top: (3 + rowIndex) * this.rowHeight + scroll.rows.shift,
        // left:
        //   column.position + this.rowHeight - scroll.columns.position

        detail = this.getDetail({
          Detail: detail,
          row: row,
          data: data,
          meta: meta.properties,
          status: _status,
          params: params,
          top: (2 + headersLength + selectedRange.end.rows - scroll.rows.startIndex) * this.rowHeight + scroll.rows.shift,
          onChange: meta.row.onChange,
          onClose: this.closeOpenedWindows
        });
      } // ------------------------
      // errors
      // ------------------------


      var toolTip = this.state.toolTip || null;

      if (toolTip) {
        var content = React.createElement("ul", {
          style: {
            paddingLeft: 20,
            maxWidth: 300
          }
        }, toolTip.content.map(function (error, index) {
          return React.createElement("li", {
            key: index
          }, error.error);
        }));
        key = "tooltip-".concat(id);
        toolTip = React.createElement("div", {
          id: key,
          key: key,
          className: "zebulon-tool-tip",
          style: {
            top: toolTip.top,
            left: toolTip.left // position: "absolute" toto

          }
        }, content);
      }

      this.rowsHeight = height - (caption ? 30 : 0) - headersLength * this.rowHeight - (actions.length ? 30 : 0); // ------------------------
      // search
      // ------------------------

      var search = null;

      if (this.state.search) {
        var _this$state3 = this.state,
            _filteredData = _this$state3.filteredData,
            _meta = _this$state3.meta,
            dataStrings = _this$state3.dataStrings,
            _scroll = _this$state3.scroll;
        key = "search-".concat(id);

        var _content = React.createElement(Search, {
          id: key,
          key: key,
          filteredData: _filteredData,
          meta: _meta,
          dataStrings: dataStrings,
          scroll: _scroll,
          rowStartIndex: _scroll.rows.startIndex + _scroll.rows.shift === 0 ? 0 : 1,
          rowStopIndex: Math.min(_scroll.rows.startIndex + Math.floor(this.rowsHeight / this.rowHeight) - (_scroll.rows.shift === 0 ? 1 : 0), _filteredData.length - 1),
          onClose: function onClose() {
            return _this2.setState({
              search: false
            });
          } // selectRange={this.selectRange_}
          ,
          selectedCell: this.state.selectedRange.end,
          scrollTo: this.scrollTo
        });

        search = React.createElement("div", {
          id: key,
          key: key,
          className: "zebulon-tool-tip",
          style: {
            top: 0,
            left: 0,
            position: "absolute"
          }
        }, _content);
      } // ----------------------------------
      // Status bar
      // ----------------------------------


      var statusBar;

      if (meta.table.noStatus) {
        statusBar = null;
      } else {
        key = "statusbar-".concat(id);
        statusBar = React.createElement(Status, {
          id: key,
          key: key,
          data: filteredData,
          status: status,
          dataLength: filteredDataLength,
          height: this.rowsHeight,
          rowHeight: this.rowHeight,
          scroll: scroll.rows,
          updatedRows: updatedRows,
          selectRange: this.selectRange,
          selectedIndex: selectedRange.end.rows,
          meta: meta,
          handleErrors: this.handleErrors,
          noUpdate: noUpdate,
          componentId: this.props.componentId,
          checkable: meta.table.checkable,
          onDoubleClick: this.onDoubleClick,
          draggable: meta.table.statusDraggable,
          isAudit: auditedRow ? true : false,
          statusChanged: statusChanged
        });
      } // -----------------------------
      //   action buttons
      // -----------------------------


      actions = actions.map(function (action, index) {
        if (!_this2.doubleClickAction && action.doubleClick) {
          _this2.doubleClickAction = action;
        }

        var enable = action.enable || false;

        if (status.loadingPage) {
          enable = false;
        } else if (action.enableFunction) {
          var _row = selectedRange.end.rows !== undefined ? _this2.getRow(selectedRange.end.rows) : {
            index_: undefined
          };

          var _status2 = updatedRows[_row.index_];
          enable = action.enableFunction({
            row: _row,
            status: _status2
          });
        }

        action.statusEnable = action.enable && enable;
        var lastColumn = meta.properties[meta.properties.length - 1];
        var actionsWidth = Math.min(lastColumn.position + lastColumn.computedWidth + _this2.rowHeight * (statusBar !== null), width - 4 * actions.length) / actions.length || 0;
        var style = {
          width: actionsWidth,
          minWidth: 50,
          margin: 2,
          marginTop: 3,
          height: 22 // backgroundColor: "lightgrey"

        };
        var className = enable ? ".zebulon-action-button" : ".zebulon-action-button-disabled";

        if (action.jsxFunction) {
          return action.jsxFunction({
            disabled: !enable,
            className: className,
            index: index,
            style: style,
            onClick: function onClick(e) {
              return _this2.handleAction(action, e);
            }
          });
        }

        key = "action-".concat(id, "-").concat(index);
        return React.createElement("button", {
          id: key,
          key: key,
          disabled: !enable,
          className: className,
          style: style,
          draggable: false,
          onClick: function onClick(e) {
            return _this2.handleAction(action, e);
          }
        }, action.caption);
      }); // -----------------------------
      //   rows
      // -----------------------------
      // let style = {};

      var locked = !utils.isNullOrUndefined(meta.lockedIndex) && !!meta.lockedWidth;
      key = "rows-".concat(id);
      var rows = React.createElement(Rows, {
        id: key,
        key: key,
        meta: meta,
        data: filteredData,
        status: status,
        dataLength: filteredDataLength,
        height: this.rowsHeight,
        width: width - this.rowHeight * (statusBar !== null) - (meta.lockedWidth || 0),
        rowHeight: this.rowHeight,
        scroll: scroll,
        onScroll: onScroll,
        selectedRange: selectedRange,
        selectRange: selectRange,
        onChange: this.onChange,
        onFocus: function onFocus(e, row, column) {
          return _this2.closeOpenedWindows(true, column, row);
        },
        hasFocus: this.hasFocus && this.props.isActive !== false,
        updatedRows: updatedRows,
        params: params,
        navigationKeyHandler: this.props.navigationKeyHandler,
        ref: function ref(_ref2) {
          return _this2.rows = _ref2;
        },
        noUpdate: noUpdate // style={style}
        ,
        onDoubleClick: this.onDoubleClick,
        componentId: this.props.componentId,
        openedFilter: this.state.openedFilter
      });
      var lockedColumns = null;

      if (locked) {
        key = "locked-columns-".concat(id);
        lockedColumns = React.createElement(Rows, {
          id: key,
          key: key,
          meta: meta,
          data: filteredData,
          status: status,
          dataLength: filteredDataLength,
          height: this.rowsHeight,
          width: meta.lockedWidth,
          rowHeight: this.rowHeight,
          scroll: scroll,
          onScroll: onScroll,
          selectedRange: selectedRange,
          selectRange: selectRange,
          onChange: this.onChange,
          onFocus: function onFocus(e, row, column) {
            return _this2.closeOpenedWindows(true, column);
          },
          hasFocus: this.hasFocus && this.props.isActive !== false,
          updatedRows: updatedRows,
          params: params,
          noUpdate: noUpdate,
          noVerticalScrollbar: true,
          onDoubleClick: this.onDoubleClick,
          locked: locked,
          componentId: this.props.componentId,
          openedFilter: this.state.openedFilter
        });
      } // -----------------------------
      //   headers
      // -----------------------------


      key = "headers-".concat(id);
      var headers = React.createElement(Headers, {
        id: key,
        key: key,
        onSort: this.onSort,
        meta: meta,
        data: data,
        height: this.rowHeight * headersLength,
        width: width - this.rowHeight * (statusBar !== null) - (meta.lockedWidth || 0),
        scroll: scroll.columns,
        headersLength: headersLength,
        onMetaChange: this.onMetaChange,
        openFilter: this.openFilter,
        onChange: this.onChangeFilter // style={style}
        ,
        componentId: this.props.componentId // auditedRow={auditedRow}
        // auditStatus={{}}
        ,
        isActive: this.props.isActive,
        onActivation: this.props.onActivation,
        changingFilter: this.changingFilter
      });
      var lockedHeaders = null;

      if (!utils.isNullOrUndefined(meta.lockedIndex) && meta.lockedWidth) {
        key = "locked-headers-".concat(id);
        lockedHeaders = React.createElement(Headers, {
          id: key,
          key: key,
          onSort: this.onSort,
          meta: meta,
          data: data,
          height: this.rowHeight * headersLength,
          width: meta.lockedWidth,
          scroll: scroll.columns,
          headersLength: headersLength,
          onMetaChange: this.onMetaChange,
          openFilter: this.openFilter,
          onChange: this.onChangeFilter,
          locked: true,
          componentId: this.props.componentId // auditedRow={auditedRow}
          // auditStatus={{}}
          ,
          isActive: this.props.isActive,
          onActivation: this.props.onActivation,
          changingFilter: this.changingFilter
        });
      } // -----------------------------
      //   status bar
      // -----------------------------


      var statusBarHeader = [];

      if (statusBar !== null) {
        for (var i = 0; i < headersLength; i++) {
          var checkbox = null;

          if (i === 0 && meta.table.checkable === true) {
            checkbox = React.createElement("input", {
              type: "checkbox",
              checked: this.state.checkAll,
              onChange: this.onCheckAll
            });
          }

          key = "status-bar-headers-".concat(id, "-").concat(i);
          statusBarHeader.push(React.createElement("div", {
            id: key,
            key: key,
            className: "zebulon-table-corner",
            style: {
              width: this.rowHeight,
              height: this.rowHeight,
              top: i * this.rowHeight // border: "0.02em solid rgba(0, 0, 0, 0.3)",
              // padding: 4

            }
          }, checkbox));
        }

        key = "header-status-".concat(id);
        statusBarHeader = React.createElement(ContextualMenuClient, {
          id: key,
          key: key,
          menu: "top-left-corner-menu",
          componentId: this.props.componentId
        }, statusBarHeader);
      } else {
        statusBarHeader = null;
      } // -----------------------------
      //   title
      // -----------------------------


      var title = null;

      if (caption) {
        key = "title-".concat(id);
        title = React.createElement(ContextualMenuClient, {
          id: key,
          key: key,
          className: "zebulon-table-title",
          style: {
            fontWeight: "bold",
            textAlign: "center",
            padding: 4,
            border: "solid 0.03em rgba(0,0,0,.2)",
            height: 30,
            width: width,
            boxSizing: "border-box"
          },
          menu: "title-menu",
          componentId: this.props.componentId,
          onClick: function onClick() {
            return _this2.props.onActivation(_this2.props.componentId || id);
          }
        }, caption);
      } // const className = "zebulon-table";


      return React.createElement("div", {
        id: id // style={{
        //   width: "max-content",
        //   height: "fit-content",
        //   ...this.props.style
        // }}
        ,
        style: _objectSpread({
          width: width,
          height: height
        }, this.props.style)
      }, React.createElement("div", {
        id: "table-".concat(id),
        style: {
          width: width,
          height: height,
          display: "block",
          position: "absolute"
        }
      }, detail, this.filter, this.text, toolTip, search, title, React.createElement("div", {
        id: "columns",
        style: {
          display: "flex"
        }
      }, statusBarHeader, lockedHeaders, headers), React.createElement("div", {
        id: "rows",
        style: {
          display: "flex"
        }
      }, statusBar, lockedColumns, rows), React.createElement("div", {
        id: "actions",
        style: {
          height: actions.length ? 30 : 0,
          display: "flex"
        }
      }, actions)));
    }
  }]);

  return Table;
}(TableFilterSort);