import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _createClass from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React, { Component } from "react"; // import * as aggregations from "../../utils/aggregation";

import { Input } from "zebulon-controls";
import { computeData, cellData } from "./utils/compute.data";
export var Property =
/*#__PURE__*/
function (_Component) {
  _inherits(Property, _Component);

  function Property(props) {
    var _this;

    _classCallCheck(this, Property);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Property).call(this, props));
    var object = props.row;
    var indexes = [13, 14, 15, 16, 17, 18]; // const items = [],

    _this.title = "Functions for analytic property";
    _this.inputs = [];
    var style = {
      textAlign: "left"
    };
    var row = props.row,
        status = props.status,
        data = props.data,
        params = props.params;
    indexes.forEach(function (index) {
      var column = props.meta[index];

      var _cellData = cellData(row, column, status, data, params, true),
          editable = _cellData.editable,
          value = _cellData.value,
          select = _cellData.select;

      _this.inputs.push(React.createElement(Input, {
        style: style,
        label: column.caption,
        select: select,
        className: "zebulon-table-input",
        row: row,
        column: column,
        id: column.id,
        key: column.id,
        inputType: "field",
        focused: true,
        editable: editable,
        value: value,
        onChange: function onChange(e) {
          return (props.onChange || function () {})(e, row, column);
        }
      }));
    });
    return _this;
  }

  _createClass(Property, [{
    key: "render",
    value: function render() {
      // onst select = ["", "a", "b", "c"];
      // const style = {
      // 	border: "solid lightgrey thin",
      // 	boxSizing: "border-box",
      // 	padding: 0,
      // 	backgroundColor: "inherit",
      // 	width: 200,
      // 	textAlign: "left"
      // };
      return React.createElement("div", {
        style: {
          position: "absolute",
          border: "solid 0.1em rgba(0, 0, 0, 0.5)",
          backgroundColor: "white",
          top: this.props.top,
          left: 25,
          zIndex: 3,
          opacity: 1,
          width: 400,
          height: "fit-content",
          autoFocus: true
        }
      }, React.createElement("div", {
        style: {
          textAlign: "Center",
          fontWeight: "bold",
          margin: 3,
          marginBottom: 7,
          display: "flex",
          justifyContent: "space-between"
        }
      }, this.title, React.createElement("button", {
        onClick: this.props.close
      }, "X")), React.createElement("div", null, this.inputs), " ");
    }
  }]);

  return Property;
}(Component);