import _objectSpread from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/objectSpread";
import _classCallCheck from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _possibleConstructorReturn from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _inherits from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import _assertThisInitialized from "C:\\Users\\thomas\\dev_js\\table\\node_modules\\@babel\\runtime/helpers/esm/assertThisInitialized";
import { Component } from "react";
import { utils } from "zebulon-controls";
import { computeMetaPositions } from "./utils/compute.meta";
import { rollback } from "./utils/utils";
export var TableMenu =
/*#__PURE__*/
function (_Component) {
  _inherits(TableMenu, _Component);

  function TableMenu() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TableMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TableMenu)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleClickMenu = function (props, item) {
      if (props.menu === "column-header-menu") {
        var column = props.column;
        var _this$state = _this.state,
            data = _this$state.data,
            meta = _this$state.meta,
            params = _this$state.params,
            scroll = _this$state.scroll;

        if (item.id <= 1) {
          if (!utils.isNullOrUndefined(meta.lockedIndex)) {
            meta.properties[meta.lockedIndex].locked = false;
          }

          if (item.id) {
            meta.properties[column.index_].locked = true;
          }

          computeMetaPositions(meta);

          _this.setState({
            scroll: _objectSpread({}, scroll, {
              columns: {
                direction: 1,
                index: 0,
                position: 0,
                shift: 0,
                startIndex: 0
              }
            })
          });
        } else {
          item.function({
            data: data,
            meta: meta,
            params: params,
            column: column,
            table: _assertThisInitialized(_assertThisInitialized(_this))
          });
        }
      } else if (props.menu === "row-header-menu") {
        var row = props.row,
            status = props.status,
            index = props.index;
        var _this$state2 = _this.state,
            _data = _this$state2.data,
            _meta = _this$state2.meta,
            _params = _this$state2.params,
            updatedRows = _this$state2.updatedRows;

        if (item.id === 0) {
          // this.rollback(updatedRows, row.index_);
          _this.setState({
            scroll: _this.state.scroll
          });
        } else if (item.id === 1) {
          var prevScroll = _this.state.scroll;
          var selectedRow = {
            rows: index,
            columns: (_this.state.meta.visibleIndexes || [0])[0]
          };
          var rows = index; // const startRowIndex = extension ? this.props.selectedIndex : index;

          var prevRange = {
            end: selectedRow,
            start: selectedRow
          };
          var selectedRange = {
            start: {
              rows: 0,
              columns: 0
            },
            end: {
              rows: 0,
              columns: 0
            }
          };
          var _scroll = {
            rows: {
              index: 0,
              direction: 1,
              startIndex: 0,
              shift: 0,
              position: 0
            },
            columns: {
              index: 0,
              direction: 1,
              startIndex: 0,
              shift: 0,
              position: 0
            }
          };

          _this.setState({
            scroll: _scroll,
            prevScroll: prevScroll,
            selectedRange: selectedRange,
            prevRange: prevRange
          });
        } else {
          return item.function({
            data: _data,
            meta: _meta,
            params: _params,
            row: row,
            status: status,
            table: _assertThisInitialized(_assertThisInitialized(_this))
          });
        }
      } else if (props.menu === "top-left-corner-menu") {
        var _this$state3 = _this.state,
            filters = _this$state3.filters,
            _data2 = _this$state3.data,
            _meta2 = _this$state3.meta,
            _params2 = _this$state3.params,
            _updatedRows = _this$state3.updatedRows;
        var filter = filters.status_;

        if (!filter) {
          filter = {
            id: "status_",
            v: 0
          };
        }

        var v = item.id % 100;

        if (filter.v & v) {
          filter.v -= v;
        } else {
          filter.v += v;
        }

        if (item.id === 2) {
          var _scroll2 = _this.state.prevScroll;
          var _selectedRange = _this.state.prevRange; // computeMetaPositions(meta);

          _this.setState({
            scroll: _scroll2,
            prevScroll: undefined,
            selectedRange: _selectedRange,
            prevRange: undefined
          });
        } else if (item.id === 0 || item.id >= 100 && item.id < 104) {
          if (item.id === 0 || filter.v === 0) {
            delete filters.status_;
          } else if (item.id >= 100) {
            filters.status_ = filter;
          }

          _this.setState({
            filteredData: _this.filters(_data2, filters, false, _updatedRows)
          });
        } else {
          item.function({
            data: _data2,
            meta: _meta2,
            params: _params2,
            table: _assertThisInitialized(_assertThisInitialized(_this))
          });
        }
      } else if (props.menu === "cell-menu") {
        var _row = props.row,
            _column = props.column;
        var _this$state4 = _this.state,
            _data3 = _this$state4.data,
            _meta3 = _this$state4.meta,
            _params3 = _this$state4.params;
        item.function({
          data: _data3,
          meta: _meta3,
          params: _params3,
          row: _row,
          column: _column,
          table: _assertThisInitialized(_assertThisInitialized(_this))
        });
      }
    };

    return _this;
  }

  return TableMenu;
}(Component); //     getCustomMenu = (menu, menus) => {
//         if (this.customContextualMenu && this.customContextualMenu[menu]) {
//             this.customContextualMenu[menu].forEach((menu, index) => {
//                 const item = {
//                     id: 1000000 + menus.length,
//                     separation: index === 0 && menus.length > 0,
//                     type: menu.type,
//                     caption: menu.caption,
//                     onClick: this.handleClickMenu,
//                     function: menu.function,
//                     children: menu.type === "sub-menu" ? [] : undefined
//                 };
//                 menus.push(item);
//             });
//         }
//     };
//     getMenu = (menu, data) => {
//         console.log(this.state, this.table.state);
//         const menus = [];
//         if (menu === "row-header-menu") {
//             if (this.state.meta.table.editable) {
//                 menus.push({
//                     id: menus.length,
//                     type: "menu-item",
//                     disable: !(data.status || {}).updated_,
//                     separation: false,
//                     caption: `Rollback row updates`,
//                     onClick: this.table.handleClickMenu
//                 });
//             }
//             if (this.state.meta.row.audit) {
//                 menus.push({
//                     id: menus.length,
//                     type: "menu-item",
//                     disable: this.state.auditedRow !== undefined,
//                     // separation: false,
//                     caption: `Audit`,
//                     onClick: this.handleAudit
//                 });
//             }
//         } else if (menu === "column-header-menu") {
//             menus.push({
//                 id: menus.length,
//                 type: "menu-item",
//                 disable: utils.isNullOrUndefined(
//                     this.table.state.meta.lockedIndex
//                 ),
//                 separation: false,
//                 caption: `Unlock columns`,
//                 onClick: this.table.handleClickMenu
//             });
//             menus.push({
//                 id: menus.length,
//                 type: "menu-item",
//                 separation: false,
//                 caption: `Lock columns until ${data.column.caption}`,
//                 onClick: this.table.handleClickMenu
//             });
//         } else if (menu === "top-left-corner-menu") {
//             if (this.state.meta.table.editable) {
//                 menus.push({
//                     id: menus.length,
//                     type: "menu-item",
//                     checked: this.table.state.filters.status_ === undefined,
//                     caption: `No status filter`,
//                     onClick: this.table.handleClickMenu
//                 });
//                 const checked = i =>
//                     (i |
//                         (this.table.state.filters.status_ || {
//                             v: 0
//                         }).v) ===
//                     (this.table.state.filters.status_ || { v: 0 }).v;
//                 menus.push({
//                     id: menus.length,
//                     type: "sub-menu",
//                     separation: menus.length > 0,
//                     caption: `Status filters`,
//                     children: [
//                         {
//                             id: 101,
//                             type: "menu-item",
//                             checked: checked(1),
//                             separation: false,
//                             caption: `Updated rows`,
//                             onClick: this.table.handleClickMenu
//                         },
//                         {
//                             id: 102,
//                             type: "menu-item",
//                             checked: checked(2),
//                             separation: false,
//                             caption: `New rows`,
//                             onClick: this.table.handleClickMenu
//                         },
//                         {
//                             id: 104,
//                             type: "menu-item",
//                             checked: checked(4),
//                             separation: false,
//                             caption: `Deleted rows`,
//                             onClick: this.table.handleClickMenu
//                         },
//                         {
//                             id: 108,
//                             type: "menu-item",
//                             // disable: utils.isNullOrUndefined(this.state.meta.lockedIndex),
//                             checked: checked(8),
//                             separation: false,
//                             caption: `Rows with errors`,
//                             onClick: this.table.handleClickMenu
//                         }
//                     ]
//                 });
//             }
//             if (this.state.meta.row.audit) {
//                 menus.push({
//                     id: menus.length,
//                     type: "menu-item",
//                     disable: this.state.auditedRow === undefined,
//                     separation: this.state.meta.table.editable,
//                     caption: `Close audit`,
//                     onClick: this.handleCloseAudit
//                 });
//             }
//         }
//         this.getCustomMenu(menu, menus);
//         if (menus.length) {
//             return {
//                 type: "menu",
//                 position: "bottom",
//                 children: menus
//             };
//         } else {
//             return null;
//         }
//     };
// }